"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var traverse_recursive_1 = require("../traverse-core/traverse-recursive");
// 迭代谓词方法
var filePredicate = function (fileNode) {
    var filePath = fileNode.filePath;
    var hasChildFile = fs_1.default.existsSync(filePath) && fs_1.default.statSync(filePath).isDirectory();
    var fileNodes = hasChildFile
        ? fs_1.default.readdirSync(filePath).map(function (file) { return ({
            fileName: file,
            filePath: path_1.default.resolve(filePath, file)
        }); })
        : [];
    return {
        done: !hasChildFile,
        iterators: fileNodes
    };
};
// 文件节点处理方法
var fileNodeHandle = function (node, nodeParams, options, result) {
    var filePath = node.filePath;
    node.fileStatus = fs_1.default.statSync(filePath);
    var fileNodeHandle = options.fileNodeHandle;
    if (fileNodeHandle && typeof fileNodeHandle === "function")
        fileNodeHandle(node, nodeParams, options, result);
    return node;
};
function traverse_file(directories, options) {
    var dirNodes = directories.map(function (dir) { return ({
        fileName: path_1.default.basename(dir),
        filePath: path_1.default.resolve(dir),
        fileStatus: fs_1.default.statSync(path_1.default.resolve(dir))
    }); });
    return traverse_recursive_1.traverse_recursive(dirNodes, Object.assign({
        predicate: filePredicate,
        nodeHandle: fileNodeHandle
    }, options));
}
exports.traverse_file = traverse_file;
