/**
 * 遍历节点
 */
export interface TraverseNode {
}
/**
 * 遍历节点相关参数
 */
export interface TraverseNodeParams {
    path: Array<TraverseNode>;
    isFirst: boolean;
    isLast: boolean;
    isLeaf: boolean;
}
/**
 * 遍历谓语结果
 */
export interface PredicateResult {
    done: boolean;
    iterators: TraverseNode[];
}
/**
 * 节点遍历谓语
 */
export declare type TraversePredicate = (node: TraverseNode) => PredicateResult;
/**
 * 文件节点处理方法
 */
export declare type TraverseNodeHandler = (node: TraverseNode, nodeParams: TraverseNodeParams, options: TraverseOptions, result: TraverseResult) => TraverseNode;
/**
 * 遍历选项
 */
export interface TraverseOptions {
    readonly predicate: TraversePredicate;
    readonly nodeHandle: TraverseNodeHandler;
    readonly exclude?: (node: TraverseNode, nodeParams: TraverseNodeParams, options: TraverseOptions) => boolean;
    readonly ignore?: (node: TraverseNode, nodeParams: TraverseNodeParams, options: TraverseOptions) => boolean;
}
export interface TraverseResult {
    [propName: string]: any;
}
/**
 * 递归遍历
 * @param nodes 遍历顶级节点
 * @param options 遍历配置项
 */
export declare function traverse_recursive(nodes: TraverseNode[], options: TraverseOptions): Promise<TraverseResult>;
