/// <reference types="node" />
import fs from "fs";
import { TraverseNode, TraverseOptions, TraverseNodeParams } from "../traverse-core/traverse-recursive";
import { PlainObject } from "../shared/types";
/**
 * 文件节点
 */
export interface FileNode extends TraverseNode {
    fileName: string;
    filePath: string;
    fileStatus: fs.Stats;
}
export declare type FileNodeHandle = (node: FileNode, params: TraverseNodeParams, options: TraverseOptions, result: PlainObject) => void;
/**
 *
 */
export interface FileTraverseOptions extends TraverseOptions {
    fileNodeHandle?: FileNodeHandle;
    [propName: string]: any;
}
export declare function traverse_file(directories: string[], options: FileTraverseOptions): Promise<import("../traverse-core/traverse-recursive").TraverseResult>;
